#include<iostream>
using namespace std;
#include "ChytrePole.h"

/* vypis pole */
void vypis(const ChytrePole &s)
{
	for (int i = 0; i < s.n; i++)
		cout << s.a[i] << " ";
	cout << endl;
}

/* dealokace = zruseni pole */
void zrus(ChytrePole &s)
{
	delete[] s.a;
	s.a = nullptr;
	s.n = 0;
	s.k = 0;
}

/* alokace = vytvoreni pole */
void vytvor(ChytrePole &s)
{
	if (s.a)
		zrus(s);
	s.a = new float[1];
	s.k = 1;
	s.n = 0;
}

/* vlozi prvek x na konec pole s */
void pridej(ChytrePole &s, float x)
{
	if (s.k == s.n)
	{
		float *nove = new float[2 * s.k];
		for (int i = 0; i < s.n; i++)
			nove[i] = s.a[i];
		delete[] s.a;
		s.a = nove;
		s.k *= 2;
	}
	s.a[s.n] = x;
	s.n++;
}

/* smaze prvek na indexu i */
void smaz(ChytrePole &s, int i)
{
	if (0 > i || i >= s.n)
		return; // throw (string)"pristup do pole mimo meze";
	for (; i < (s.n - 1); i++)
		s.a[i] = s.a[i + 1];
	s.n--;
}

